<?php
class ControllerPaymentIpasspay extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('payment/ipasspay');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('ipasspay', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_all_zones'] = $this->language->get('text_all_zones');
		$data['text_payment'] = $this->language->get('text_payment');

		$data['text_mid'] = $this->language->get('text_mid');
		$data['text_api_key'] = $this->language->get('text_api_key');
		$data['text_site_id'] = $this->language->get('text_site_id');
		$data['text_gateway_url'] = $this->language->get('text_gateway_url');
		$data['text_gateway_version'] = $this->language->get('text_gateway_version');

		$data['entry_total'] = $this->language->get('entry_total');
		$data['entry_order_status'] = $this->language->get('entry_order_status');
		$data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$data['entry_mid'] = $this->language->get('entry_mid');
		$data['entry_api_key'] = $this->language->get('entry_api_key');
		$data['entry_site_id'] = $this->language->get('entry_site_id');
		$data['entry_gateway_url'] = $this->language->get('entry_gateway_url');
		$data['entry_gateway_version'] = $this->language->get('entry_gateway_version');

		$data['help_total'] = $this->language->get('help_total');
		$data['help_transaction'] = $this->language->get('help_transaction');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['mid'])) {
			$data['error_mid'] = $this->error['mid'];
		} else {
			$data['error_mid'] = '';
		}

		if (isset($this->error['api_key'])) {
			$data['error_api_key'] = $this->error['api_key'];
		} else {
			$data['error_api_key'] = '';
		}

		if (isset($this->error['site_id'])) {
			$data['error_site_id'] = $this->error['site_id'];
		} else {
			$data['error_site_id'] = '';
		}

		if (isset($this->error['gateway_url'])) {
			$data['error_gateway_url'] = $this->error['gateway_url'];
		} else {
			$data['error_gateway_url'] = '';
		}

		if (isset($this->error['gateway_version'])) {
			$data['error_gateway_version'] = $this->error['gateway_version'];
		} else {
			$data['error_gateway_version'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true),
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('extension', 'token=' . $this->session->data['token'] . '&type=payment', true),
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('payment/ipasspay', 'token=' . $this->session->data['token'], true),
		);

		$data['action'] = $this->url->link('payment/ipasspay', 'token=' . $this->session->data['token'], 'SSL');

		$data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL');

		if (isset($this->request->post['ipasspay_mid'])) {
			$data['ipasspay_mid'] = $this->request->post['ipasspay_mid'];
		} else {
			$data['ipasspay_mid'] = $this->config->get('ipasspay_mid');
		}

		if (isset($this->request->post['ipasspay_api_key'])) {
			$data['ipasspay_api_key'] = $this->request->post['ipasspay_api_key'];
		} else {
			$data['ipasspay_api_key'] = $this->config->get('ipasspay_api_key');
		}

		if (isset($this->request->post['ipasspay_site_id'])) {
			$data['ipasspay_site_id'] = $this->request->post['ipasspay_site_id'];
		} else {
			$data['ipasspay_site_id'] = $this->config->get('ipasspay_site_id');
		}

		if (isset($this->request->post['ipasspay_gateway_url'])) {
			$data['ipasspay_gateway_url'] = $this->request->post['ipasspay_gateway_url'];
		} else {
			$data['ipasspay_gateway_url'] = $this->config->get('ipasspay_gateway_url');
		}

		if (isset($this->request->post['ipasspay_gateway_version'])) {
			$data['ipasspay_gateway_version'] = $this->request->post['ipasspay_gateway_version'];
		} else {
			$data['ipasspay_gateway_version'] = $this->config->get('ipasspay_gateway_version');
		}

		if (isset($this->request->post['ipasspay_total'])) {
			$data['ipasspay_total'] = $this->request->post['ipasspay_total'];
		} else {
			$data['ipasspay_total'] = $this->config->get('ipasspay_total');
		}

		if (isset($this->request->post['ipasspay_order_status_id'])) {
			$data['ipasspay_order_status_id'] = $this->request->post['ipasspay_order_status_id'];
		} else {
			$data['ipasspay_order_status_id'] = $this->config->get('ipasspay_order_status_id');
		}

		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['ipasspay_geo_zone_id'])) {
			$data['ipasspay_geo_zone_id'] = $this->request->post['ipasspay_geo_zone_id'];
		} else {
			$data['ipasspay_geo_zone_id'] = $this->config->get('ipasspay_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['ipasspay_status'])) {
			$data['ipasspay_status'] = $this->request->post['ipasspay_status'];
		} else {
			$data['ipasspay_status'] = $this->config->get('ipasspay_status');
		}

		if (isset($this->request->post['ipasspay_sort_order'])) {
			$data['ipasspay_sort_order'] = $this->request->post['ipasspay_sort_order'];
		} else {
			$data['ipasspay_sort_order'] = $this->config->get('ipasspay_sort_order');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('payment/ipasspay.tpl', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'payment/ipasspay')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['ipasspay_mid']) {
			$this->error['mid'] = $this->language->get('error_mid');
		}

		if (!$this->request->post['ipasspay_api_key']) {
			$this->error['api_key'] = $this->language->get('error_api_key');
		}

		if (!$this->request->post['ipasspay_site_id']) {
			$this->error['site_id'] = $this->language->get('error_site_id');
		}

		if (!$this->request->post['ipasspay_gateway_url']) {
			$this->error['gateway_url'] = $this->language->get('error_gateway_url');
		}

		if (!$this->request->post['ipasspay_gateway_version']) {
			$this->error['gateway_version'] = $this->language->get('error_gateway_version');
		}

		return !$this->error;
	}
}
